Lua_LuckyTurntableRecordWindow = class("Lua_LuckyTurntableRecordWindow", Lua_Window);
function Lua_LuckyTurntableRecordWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_LuckyTurntableRecordWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.recordBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_009", 6, 59, 511, 593);

	self.recordList = Lua_DragList.new(self.content, 458, 533, Lua_AxisDefine.Vertical);
	self.recordList:setListCell(Lua_AllTurntableRecordItem, 458, 24, 1);
	self.recordList:setCellSpacing(0, 6, 0);
	self.recordList:setLocation(16, 326, 0);
	self.recordList:setRectPivot(1);

	local curSelectType = DataCenter.luckyTurntableData.curSelectType;
	local recordInfo = DataCenter.luckyTurntableData.turnTableInfo[curSelectType].recordInfo;
	self.recordList:setArrayData(recordInfo);
end

function Lua_LuckyTurntableRecordWindow:dispose()
	if self.recordList ~= nil then
		self.recordList:dispose();
		self.recordList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_AllTurntableRecordItem = class("Lua_AllTurntableRecordItem", Lua_ListCell);
function Lua_AllTurntableRecordItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_AllTurntableRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.des = UICreate.createLabel(self.content, "", 0, 0, 450, 35, 26); -- 380
	self.des.fontSize = 22;
	self.des.alignmentValue = 3;
	-- self.des.horizontalOverflowValue = 1;
end

function Lua_AllTurntableRecordItem:setData(data)
	self.data = data;
	if data == nil then
		return ;
	end

	-- 使 “获得了” 居中
	-- local nameLen = self:nameLen(data.player_name);
	-- local playerName = data.player_name;
	-- for i=1, 6-nameLen do
	-- 	playerName = " "..playerName;
	-- end

	local tvo = Lua_ToolVo.createToolVo( tonumber(data.item_id) );
	if tvo == nil then return; end;
	local rewardStr = tonumber(data.amount);
	local rewardColStr;
	rewardStr = rewardStr == 1 and tvo.name or LanUtil.formateStr(200708, tvo.name, rewardStr);--.."*"..;
	rewardColStr = Lua_ColorDefine.getColorStr(tvo.colorStr, rewardStr);
	self.des.text = LanUtil.formateStr(200707, data.player_name, "<url=showItem>"..rewardColStr.."</url>"); -- playerName, data.reward_name);
end

-- function Lua_AllTurntableRecordItem:onPressClick(go)
-- 	local urlStr = self.des:getUrlByMousePos();
-- 	Lua_ChatUtil.urlClickHandle(urlStr, itemVoInfo);
-- end

-- UTF编码里面，字符的第一个字节范围是(0-127)或者(194-244)，英文是单字节即都在这个范围内，中文是双字节，所以第一个字节在这个范围内，第二个在128到193内
function Lua_AllTurntableRecordItem:nameLen(nameStr)
    local bytes = { string.byte(nameStr, 1, #nameStr) };
    local length = 0;
    for _,byte in ipairs(bytes) do
        if byte < 128 or byte > 193 then
            length = length + 1;
        end
    end
    return length;
end

function Lua_AllTurntableRecordItem:dispose()
	if self.des ~= nil then
		self.des:dispose();
		self.des = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end