Lua_LuckyTurntableRuleWindow = class("Lua_LuckyTurntableRuleWindow", Lua_Window);
function Lua_LuckyTurntableRuleWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -570;

	self.windowName = "Lua_LuckyTurntableRuleWindow";
	self.skinName = "LuckyTurntableRuleWindow_skin";
end

function Lua_LuckyTurntableRuleWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- self.winBg:setUrl("/images/common/ui_common_window_011.png");

	self.tipTxt:setLangValue(200712);
	self.initialHeight = 337;
	self.ruleTxt = UICreate.createLabel(self.content, "", 0, 0, 500, 0, 26);
	self.ruleTxt.verticalOverflowValue = 1;
	self.ruleTxt.alignmentValue = 3;
	self.ruleTxt.fontSize = 20;
	self.ruleTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
	self.ruleTxt.fontName = Lua_MyUISettings.defaultFontName;
	self.ruleTxt.lineSpacing = 1.4;

	self.rewardList = Lua_DragList.new(self.content, 500, 325, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_LuckyTurntableRewardItem, 500, 30, 1);
	self.rewardList:setLocation(0, -237, 0);
	self.rewardList:setRectAnchor(7);
end

function Lua_LuckyTurntableRuleWindow:showWin(param)
	-- 抽奖：普通轮盘：概率还是  高级轮盘：光暗 / 四系概率
	local probabilityName = param == Lua_LuckyTurntableData.ordinaryTurnTable and LanUtil.getValue(200713) or LanUtil.getValue(200714);
	self.probabilityTipTxt.text = probabilityName;

	-- 规则
	local posY;
	local height;
	local distance;
	local ruleStr = DataCenter.luckyTurntableData:getRuleByType(param);	
	self.ruleTxt.text = ruleStr;
	self.ruleTxt:resetSize();
	height = self.ruleTxt.height;
	distance = height/2;
	posY = self.initialHeight - distance;
	self.ruleTxt:setLocation(0, posY);

	-- 奖励
	-- distance = posY;
	posY = posY - distance - 37; -- 《37》self.rewardTipObj与文本之间的间隔
	LuaUtil.setObjPos(self.rewardTipObj, -1, posY, 0);

	local rewardList = DataCenter.luckyTurntableData:getRewardIndexesByType(param);
	local rectY = 325 + 309 - height;-- 《325》为self.rewardList原本的rectY 《309》为预设的文本高度
	isOverStep = #rewardList * 30 > rectY;
	self.rewardList:setLocation(0, -237 + (309 - height)/2);-- 《-237》为self.rewardList原本的位置y
	self.rewardList:setContentRect(500, rectY);
	self.rewardList:setArrayData(rewardList);
	self.rewardList.canDrag = isOverStep;
end

function Lua_LuckyTurntableRuleWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end

	self:superCall("dispose");
end






--------------------------------------------------





Lua_LuckyTurntableRewardItem = class("Lua_LuckyTurntableRewardItem", Lua_ListCell);
function Lua_LuckyTurntableRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LuckyTurntableRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemNameTxt = UICreate.createLabel(self.content, "", -75, 0, 350, 30, 26); -- 380
	self.itemNameTxt.alignmentValue = 3;
	self.itemNameTxt.fontSize = 20;
	self.itemNameTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
	self.itemNameTxt.fontName = Lua_MyUISettings.defaultFontName;
	self.itemNameTxt.lineSpacing = 1.3;

	self.probabilityTxt = UICreate.createLabel(self.content, "", 172, 0, 140, 30, 26); -- 380
	self.probabilityTxt.alignmentValue = 4;
	self.probabilityTxt.fontSize = 20;
	self.probabilityTxt.colorStr = Lua_ColorDefine.transColorStr("796353");
	self.probabilityTxt.fontName = Lua_MyUISettings.defaultFontName;
	self.probabilityTxt.lineSpacing = 1.3;
end

function Lua_LuckyTurntableRewardItem:setData(data)
	if data == nil then
		return;
	end

	local vo = DataCenter.luckyTurntableData:getLuckRouletteById(data);
	self.itemNameTxt.text = LanUtil.formateStr(200715,vo.itemName);
	self.probabilityTxt.text = LanUtil.formateStr(200715,vo.probability);
end

-- function Lua_LuckyTurntableRewardItem:onPressClick(go)
-- end

function Lua_LuckyTurntableRewardItem:dispose()
	if self.itemNameTxt ~= nil then
		self.itemNameTxt:dispose();
		self.itemNameTxt = nil;
	end
	if self.probabilityTxt ~= nil then
		self.probabilityTxt:dispose();
		self.probabilityTxt = nil;
	end

	self:superCall("dispose");
end