-- 幸运转盘
Lua_LuckyTurntableWindow = class("Lua_LuckyTurntableWindow", Lua_Window);
function Lua_LuckyTurntableWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LuckyTurntableWindow";
	self.skinName = "LuckyTurntableWindow_skin";
	self.layer = MainWinDefine.MAIN_MENU_LAYER;
	self.showWinBg = true;
	self.showBackBtn = true;
	self.isFullSizeWin = true;
	self.isFullPaving = true;

	self:preLoadSelfRes();
	self.winBgPath = self.ordinaryBgPath;
end

-- 预加载资源
function Lua_LuckyTurntableWindow:preLoadSelfRes()
	self.ordinaryBgPath = "/images/turntable/ui_xyzp_bg_01.jpg";
	self.seniorBgPath = "/images/turntable/ui_xyzp_bg_02.jpg";
	self.rotatingSpPath = "/images/turntable/ui_xyzp_widget_001.png";
	self.ordinaryTurntablePath = "/images/turntable/ui_xyzp_widget_002.png";
	self.seniorTurntablePath = "/images/turntable/ui_xyzp_widget_007.png";

	self:addPreLoadRes(self.ordinaryBgPath, Lua_LoadFileType.IMG); -- 后续如果初始化界面要调整默认选项，请动态赋值
	-- self:addPreLoadRes(self.seniorBgPath, Lua_LoadFileType.IMG);
	-- self:addPreLoadRes(self.rotatingSpPath, Lua_LoadFileType.IMG);
	-- self:addPreLoadRes(self.ordinaryTurntablePath, Lua_LoadFileType.IMG);
	-- self:addPreLoadRes(self.seniorTurntablePath, Lua_LoadFileType.IMG);	
end

function Lua_LuckyTurntableWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isRotate = false;
	self.showItemArr = Array();

	self.rotatingSp:setUrl(self.rotatingSpPath);
	Lua_CommonUtil.addTimer("onRotatingSp", 0.01, self, self.onRotatingSp);

	self.oneBtn.label = LanUtil.formateStr(200701, 1);

	self.wishProgressBarIcon.fillMethodValue = 4;
	self.wishProgressBarIcon.fillOrigin = 2;

	self.wishIcon = Lua_ItemIcon.new(self.content);
	self.wishIcon:setCanClick(true);
	self.wishIcon:setRectAnchor(1);
	self.wishIcon:setLocation(3, -537);
	self.wishIcon:setScale(0.9, 0.9, 1);

	self.btnInfo = Array();
	self.btnInfo:add({id = Lua_LuckyTurntableData.ordinaryTurnTable, textAtlas = "turntable_atlas", textUnOpenSprite = "ui_xyzp_button_01_d", textNormalSprite = "ui_xyzp_button_01_n", textSelectedSprite = "ui_xyzp_button_01_p", redPointId = Lua_RedPointList.LuckyTurntable_ordinary, openId = 10204});
	self.btnInfo:add({id = Lua_LuckyTurntableData.seniorTurnTable,   textAtlas = "turntable_atlas", textUnOpenSprite = "ui_xyzp_button_02_d", textNormalSprite = "ui_xyzp_button_02_n", textSelectedSprite = "ui_xyzp_button_02_p", redPointId = Lua_RedPointList.LuckyTurntable_senior, openId = 10205});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList.pivot = -1;
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(240, 60.5, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 118, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "xui_common_line_001", 2, 118, 0, 0, 1);
	self.btnList:setButtonItem(120, 118);
	self.btnList:setRedPoint(42, 41);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(self.btnInfo);
	self.btnList:setSelected(1);

	self.mask.siblingIndex = self.btnList.siblingIndex + 1;
	self.mask:SetDimensions(self.width, self.height);
	self.mask:addClickFuntion(self, self.onMaskClick);
	self.mask:setEnable(false);

	self.introduceIcon:addClickFuntion(self, self.onIntroduceClick);
	self.wishRewardIcon:addClickFuntion(self, self.onSelectWishRewardClick);
	self.reSelectIcon:addClickFuntion(self, self.onSelectWishRewardClick);
	self.skipAniBox:addBoxChange(self, self.onSkipAniBoxClick);
	self.gotoRecordTxt:addClickFuntion(self, self.onShowRecordInfoClick);
	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.freeSp:addClickFuntion(self, self.onFreeSpClick);
	self.manayBtn:addClickFuntion(self, self.onManayBtnClick);

	self:calculateItemPosList();

	self:addLuaEvent("AGAIN_ONE_REWARD", self, self.onOneBtnClick); -- 再抽一次
	self:addLuaEvent("AGAIN_TEN_REWARD", self, self.onManayBtnClick); -- 再抽十次
	self:addLuaEvent("RESET_TURNTABLE_REWARD", self, self.resetRewardStage); -- 奖励窗口关闭后，执行道具更新等
	self:addLuaEvent("UPDATE_LUCKY_TURNTABLE_INFO", self, self.updateTurntableInfo); -- 轮盘界面信息返回
	self:addLuaEvent("UPDATE_LUCKY_TURNTABLE_WISHHERO", self, self.updateWishHero); -- 心愿英雄
	self:addLuaEvent("UPDATE_LUCKY_TURNTABLE_REWARD_INFO", self, self.rewardRotateDisplay); -- 抽奖执行动画
	self:addLuaEvent("UPDATE_ORDINARYTURNTABLE_MANYBTNCOST", self, self.updateNormalTurntableTenCost); -- 当VIP等级改变时，普通多抽消耗数量更新
	self:addLuaEvent("UPDATE_LUCKY_TURNTABLE_REDPOINT", self, self.updateCoinItemCounts); -- 获得道具时，更新红点及道具消耗数量

	-- 当天首次打开后，LuckyTurntable_firstOpen红点取消
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.LuckyTurntable_firstOpen, false);
end

function Lua_LuckyTurntableWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.mask:SetDimensions(self.width, self.height);
end

-- 旋转背景
function Lua_LuckyTurntableWindow:onRotatingSp()
	self.rotatingSp:setRot(0, 0, -getTime() * 100 % 360);
end

-- 记录每个奖励的位置
function Lua_LuckyTurntableWindow:calculateItemPosList()
	if self.recordItemPosList == nil then
		self.recordItemPosList = {};
		local obj;
		local posX;
		local posY;
		local count;
		local angle;
		local radius = 220; -- 道具的半径
		for i = 1, self.btnInfo:getSize() do
			obj = self.btnInfo[i];
			count = obj.id == Lua_LuckyTurntableData.ordinaryTurnTable and 7 or 9;
			angle = 360 / count;
			self.recordItemPosList[obj.id] = {};
			for j = 1, count do
				posX = 3 + radius * Mathf.Sin(Mathf.Rad(angle * (j - 1 + 0.5))); -- +0.5 使得item处于轮盘格子中央，而非分界线
				posY = -537 + radius * Mathf.Cos(Mathf.Rad(angle * (j - 1 + 0.5)));
				self.recordItemPosList[obj.id][j] = { posX, posY };
			end
		end
	end
end

function Lua_LuckyTurntableWindow:onBtnClick(val)
	if self.curType == val then 
		return;
	end
	self.curType = val;
	DataCenter.luckyTurntableData.curSelectType = val;

	-- 选中状态初始位置
	local rotateAngle = self.curType == Lua_LuckyTurntableData.ordinaryTurnTable and 4 or 5;
	self.rewardCount = self.curType == Lua_LuckyTurntableData.ordinaryTurnTable and 7 or 9;
	self.perRewardAngle = 360 / self.rewardCount; -- 每个格子所占的角度
	self.rotateSp:setRot(0, 0, self.perRewardAngle * rotateAngle);
	self.rotationCount = self.rotationCount or 0;
	LuaUtil.setObjRot(self.rotateIcon, 0, 0, -self.rotationCount * self.perRewardAngle);

	self:updateTypeInfo(val);
	Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sLuckyTurntableInfo(val);
end

function Lua_LuckyTurntableWindow:updateTypeInfo(val)
	local state = val == Lua_LuckyTurntableData.ordinaryTurnTable;
	local winPath = state and self.ordinaryBgPath or self.seniorBgPath;
	self.winBg:setUrl(winPath);

	local turntableBgPath = state and self.ordinaryTurntablePath or self.seniorTurntablePath;
	self.turntableBg:setUrl(turntableBgPath);

	local rotateIconName = state and "ui_xyzp_widget_004" or "ui_xyzp_widget_008";
	self.rotateSp:setAltas("turntable_atlas", rotateIconName);
	self.rotateSp:resetSize();
	
	if self.showItemArr:getSize() > 0 then
		for i = 1, self.showItemArr:getSize() do
			self.showItemArr[i]:setEnable(false);
		end
	end

	self.freeSp:setEnable(state);
	self.freeTxt:setEnable(state);
end

-- 幸运转盘界面信息
function Lua_LuckyTurntableWindow:updateTurntableInfo()
	local turnTableInfo = DataCenter.luckyTurntableData.turnTableInfo[self.curType];
	if turnTableInfo == nil then
		return;
	end

	self:updateWishHero();
	self:updateRewardInfo();
	self:updateSkipAniState();
	self:updateCoinItemCounts();
	self:updateRecordTxt(turnTableInfo.recordInfo[1]);
	self:startIdleRotation();
end

-- 设置心愿英雄icon、心愿
function Lua_LuckyTurntableWindow:updateWishHero()
	self:updateWishValue();

	local hasWish = self.wishId ~= 0;
	if hasWish then
		local wishRewardInfo = DataCenter.luckyTurntableUtil:getWishRewardByWishId(self.wishId);
		local rewardInfo = Lua_ToolVo.createToolVo(wishRewardInfo.reward_item[1], wishRewardInfo.reward_item[2]);
		self.wishIcon:setData(rewardInfo);
	end
	self.wishIcon:setEnable(hasWish);
	self.reSelectIcon:setEnable(hasWish);
end

-- 更新心愿值
function Lua_LuckyTurntableWindow:updateWishValue()
	local turnTableInfo = DataCenter.luckyTurntableData.turnTableInfo[self.curType];
	self.wishId = turnTableInfo == nil and 0 or turnTableInfo.wishId;
	if self.wishId ~= 0 then
		local wishRewardInfo = DataCenter.luckyTurntableUtil:getWishRewardByWishId(self.wishId);
		self.wishProgressBarIcon.fillAmount = 1 - turnTableInfo.wishLeftTimes / wishRewardInfo.guarantee_times;
		self.wishPercentTxt.text = Mathf.Floor((1 - turnTableInfo.wishLeftTimes / wishRewardInfo.guarantee_times) * 100).."%";
	else
		self.wishProgressBarIcon.fillAmount = 0;
		self.wishPercentTxt.text = "0%";
	end
end

-- 更新道具的信息（置灰、icon）
function Lua_LuckyTurntableWindow:updateRewardInfo()
	local rewardInfo;
	if self.curType == Lua_LuckyTurntableData.ordinaryTurnTable then
		rewardInfo = DataCenter.luckyTurntableData.turnTableInfo[self.curType].rewardInfo;
	else
		rewardInfo = DataCenter.luckyTurntableUtil.seniorTurntableShowReward;
	end

	local item;
	local posList = self.recordItemPosList[self.curType];
	for i = 1, self.rewardCount do
		item = self.showItemArr[i];
		if item == nil then
			item = Lua_TurntableItem.new(self.content);
			item:setRectAnchor(1);
			item:setSiblingIndex(12);
			self.showItemArr:add(item);
		end
		item.contentName = "Lua_TurntableItem"..i;
		item:setEnable(true);
		item:setLocation(posList[i][1], posList[i][2], 0);
		item:setData(rewardInfo[i]);
	end
end

-- 动画是否跳过
function Lua_LuckyTurntableWindow:updateSkipAniState()
	local isSkip = DataCenter.luckyTurntableData.turnTableInfo[self.curType].isSkipAni;
	self.skipAniState = isSkip == 1;
	self.skipAniBox.selected = self.skipAniState;
end

-- 更新奖励记录
function Lua_LuckyTurntableWindow:updateRecordTxt(recordInfo)
	if recordInfo ~= nil then 
		local tvo = Lua_ToolVo.createToolVo( tonumber(recordInfo.item_id) );
		local itemName = tvo == nil and "" or tvo.colorName;
		self.recordTxt.text = LanUtil.formateStr(200700, recordInfo.player_name, itemName);
	else
		self.recordTxt.text = "";
	end
end

-- 更新消耗道具数量，及红点，刷新道具
function Lua_LuckyTurntableWindow:updateCoinItemCounts()
	self:updateCoinCounts();

	-- 更新刷新消耗道具
	if self.curType == Lua_LuckyTurntableData.ordinaryTurnTable then
		local turnTableInfo = DataCenter.luckyTurntableData.turnTableInfo[self.curType];
		if turnTableInfo.refreshState == 0 then
			self.lastTime = turnTableInfo.lastRefreshTick or 0; -- 上次刷新的时间
			self:startFreeTimer();
			self:updateFreeTimer();

			local info = DataCenter.luckyTurntableUtil:getTurntableConstConfig("normal_pay_refresh_consume", 4);
			local tvo = Lua_ToolVo.createToolVo(info[1][1]);
			local itemInfo = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth * 0.8, tvo.iconHeight * 0.8);
			-- local itemInfo = spliceIconStrById(info[1][1]);
			local str = spliceStr(itemInfo, info[1][2]);
			self.freeTxt.text = LanUtil.formateStr(200711, str);
		else
			self:endFreeTimer();
			self:showFreeTxt();
		end
	else
		local residueCount = DataCenter.luckyTurntableData.seniorResidueTimes;
		local totalCount = DataCenter.luckyTurntableUtil.totalDrawCount;
		local str = residueCount > 0 and 200721 or 200722;
		self.remainTime.text = LanUtil.formateStr(str, residueCount, totalCount);
		self:endFreeTimer();
	end
end

-- 更新消耗道具数量，及红点
function Lua_LuckyTurntableWindow:updateCoinCounts()
	self:updateCoin();

	-- 更新单抽数量文本
	local haveCount = DataCenter.packData:getItemCountById(self.oneCoinId);
	local strStye = haveCount >= self.oneCostNum and LanUtil.getValue(200709) or LanUtil.getValue(200710);
	self.oneCount.text = LanUtil.formateStr(strStye, numberTrans(haveCount), self.oneCostNum);
	-- 更新多抽数量文本
	haveCount = DataCenter.packData:getItemCountById(self.tenCoinId);
	strStye = haveCount >= self.tenCostNum and LanUtil.getValue(200709) or LanUtil.getValue(200710);
	self.tenCount.text = LanUtil.formateStr(strStye, numberTrans(haveCount), self.tenCostNum);
	self:showRedDot( haveCount >= self.tenCostNum );
end

-- 更新消耗道具图标
function Lua_LuckyTurntableWindow:updateCoin()
	local isOrdinaryTurnTable = self.curType == Lua_LuckyTurntableData.ordinaryTurnTable;
	if isOrdinaryTurnTable then -- 普通抽奖
		local info = DataCenter.luckyTurntableUtil:getTurntableConstConfig("normal_single_draw", 4);
		self.oneCoinId = info[1][1]; -- 一抽消耗道具id
		self.oneCostNum = info[1][2]; -- 一次抽奖消耗的道具数量

		info = DataCenter.vipData:getVipVoByLevel(DataCenter.roleData.vip).normal_turntable_ten_cost;
		self.tenCoinId = info[1][1];
		self.tenCostNum = info[1][2];
	else -- 高级抽奖
		local _type = DataCenter.luckyTurntableUtil:getTurntableConstConfig("advanced_multi_draw", 1);
		self.oneCoinId, self.oneCostNum = DataCenter.luckyTurntableData:judgeCostIdByType(1);
		self.tenCoinId, self.tenCostNum = DataCenter.luckyTurntableData:judgeCostIdByType(_type);
	end

	-- 图标更新
	local tvo = Lua_ToolVo.createToolVo(self.oneCoinId);
	self.oneMoneyIcon:setAltas(tvo.atlas, tvo.sprite);
	self.oneMoneyIcon:SetDimensions(tvo.iconWidth, tvo.iconHeight);
	tvo = Lua_ToolVo.createToolVo(self.tenCoinId);
	self.tenMoneyIcon:setAltas(tvo.atlas, tvo.sprite);
	self.tenMoneyIcon:SetDimensions(tvo.iconWidth, tvo.iconHeight);

	-- 多次抽奖按钮的显示文本
	local key = self.curType == Lua_LuckyTurntableData.ordinaryTurnTable and "normal_multi_draw" or "advanced_multi_draw";
	self.manayBtn.label = LanUtil.formateStr(200701, DataCenter.luckyTurntableUtil:getTurntableConstConfig(key, 1));

	self:openManyBtn();
end

function Lua_LuckyTurntableWindow:openManyBtn()
	-- 多抽按钮解锁VIP等级
	local key = self.curType == Lua_LuckyTurntableData.ordinaryTurnTable and "normal_multi_draw" or "advanced_multi_draw";
	self.vipLvLimit = DataCenter.luckyTurntableUtil:getTurntableConstConfig(key, 2);
	self.isOpenManyBtn = DataCenter.roleData.vip >= self.vipLvLimit;
end

function Lua_LuckyTurntableWindow:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(275, 299, 0);
			self.redPoint:setRectAnchor(7);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

-- 免费刷新倒计时开始
function Lua_LuckyTurntableWindow:startFreeTimer()
	if self.countFreeDown ~= true then
		self.countFreeDown = true;
		Lua_CommonUtil.addTimer("updateFreeTimer", 1, self, self.updateFreeTimer);
	end
end

-- 显示距免费刷新的时间文本
function Lua_LuckyTurntableWindow:updateFreeTimer()
	if self.totalTimes == nil then
		self.totalTimes = DataCenter.luckyTurntableUtil:getTurntableConstConfig("normal_free_refresh_interval", 1);
	end
	
	local remainTime = self.totalTimes - (DataCenter.roleData.serverTime - self.lastTime);
	if remainTime > 0 then
		self.remainTime.text = LanUtil.formateStr(200703, Lua_TimeTransform.transSeconds6(remainTime, true, true));
	else
		self:endFreeTimer();
		self:showFreeTxt();
	end
end

-- 免费刷新倒计时结束
function Lua_LuckyTurntableWindow:endFreeTimer()
	if self.countFreeDown == true then
		self.countFreeDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateFreeTimer);
	end
end

-- 当刷新为免费时，文本显示
function Lua_LuckyTurntableWindow:showFreeTxt()
	self.remainTime.text = "";
	self.freeTxt:setLangValue(200702);
end

-- 开始待机旋转计时器
function Lua_LuckyTurntableWindow:startIdleRotation()
	if self.isIdleRotate ~= true then
		self.isIdleRotate = true;
		self:updateIdleRotation();
		Lua_CommonUtil.addTimer("LuckyTurntable_IdleRotation", 1, self, self.updateIdleRotation);
	end
end

-- 更新待机旋转动画
function Lua_LuckyTurntableWindow:updateIdleRotation()
	local count = (self.rotationCount + 1) % self.rewardCount; -- 当前的旋转格子数
	self.rotationCount = count == 0 and self.rewardCount or count;
	LuaUtil.setObjRot(self.rotateIcon, 0, 0, -self.rotationCount * self.perRewardAngle);
end

-- 结束待机旋转计时器
function Lua_LuckyTurntableWindow:endIdleRotation()
	if self.isIdleRotate == true then
		self.isIdleRotate = false;
		Lua_CommonUtil.removeTimer(self, self.updateIdleRotation);
	end
end

-- 抽奖展示：执行展示奖励、动画播放
function Lua_LuckyTurntableWindow:rewardRotateDisplay(isPlay)
	self:updateCoinItemCounts();
	if self.skipAniState == false and isPlay == true then -- 动画不跳过
		self:startUpdateRewardRotation();
	else
		self:showRewardsInfo(); -- 展示奖励
	end
end

-- 显示奖励，播放广播
function Lua_LuckyTurntableWindow:showRewardsInfo()
	local drawResult = DataCenter.luckyTurntableData.turnTableInfo[self.curType].drawResult;
	local obj;
	local vo;
	local rewardArr = Array();
	for i = 1, #drawResult do
		obj = drawResult[i].item_info;
		vo = DataCenter.packData:getRewardVo(obj);
		rewardArr:add(vo);
	end
	Lua_WindowUtil.openWin("Lua_LuckyShowRewardWindow", Lua_WinParam.ACTION_OPEN, rewardArr);

	DataCenter.chatData:setBoardPlayState(2, true); -- 播放广播
end

-- 开始抽奖旋转动画
function Lua_LuckyTurntableWindow:startUpdateRewardRotation()
	if self.startRewardRotation ~= true then
		self.startRewardRotation = true;

		-- 旋转的总格子数 = 当前格子数到起点的格子数 + 旋转圈数的格子数 + 目标格子数
		local toStartNum = self.rewardCount - self.rotationCount; -- 当前格子数到起点的格子数
		local needRotNum = DataCenter.luckyTurntableUtil.rotationNumber * self.rewardCount; -- 旋转圈数的格子数
		local targetCell = DataCenter.luckyTurntableData.rewardCell; -- 目标格子
		self.rotationNumber = toStartNum + needRotNum + targetCell; -- 旋转的总格子数
		self.rotationTime = self.rotationTime or DataCenter.luckyTurntableUtil.rotationTime; -- 轮盘旋转时间

		-- 等差
		-- local lastNum = self.rotationTime * 2 / self.toatlRotationNumber - 0.01;
		-- self.residueNum = (lastNum - 0.01) / (self.toatlRotationNumber - 1);
		-- y = x^2
		self.accelateNum = 6 * self.rotationTime / ((Mathf.Pow(self.rotationNumber, 2) + self.rotationNumber) * (2 * self.rotationNumber + 1));
		self.lastNum = self.accelateNum * Mathf.Pow(self.rotationNumber, 2);
		self.residue = self.residue or DataCenter.luckyTurntableUtil.rotationResidue;
		self.toatlRotationNumber = self.rotationNumber + self.rewardCount; -- 加一圈作为缓冲

		self:updateRewardRotation();
		Lua_CommonUtil.addTimer("LuckyTurntable_RewardRotation", 0.01, self, self.updateRewardRotation);
	end
end

-- 更新抽奖旋转动画
function Lua_LuckyTurntableWindow:updateRewardRotation()
	self.curRotationNum = self.curRotationNum ~= nil and self.curRotationNum + 1 or 1;
	if self.curRotationNum > self.toatlRotationNumber then
		self.curRotationNum = nil;
		-- self.toatlRotationNumber = nil;
		self.rotationNumber = nil;
		self.curSecNum = nil;
		self.curNum = nil;

		self.rotationCount = DataCenter.luckyTurntableData.rewardCell;
		self.showItemArr[self.rotationCount]:setIconBg("ui_xyzp_toggle_002_f");
		self:endRewardRotation(); -- 移除变速旋转
		self:startLighting();
	else
		local count = (self.rotationCount + 1) % self.rewardCount;
		self.rotationCount = count == 0 and self.rewardCount or count;-- 当前的旋转格子数
		LuaUtil.setObjRot(self.rotateIcon, 0, 0, -self.rotationCount * self.perRewardAngle);

		self.curSecNum = self.curSecNum or 0.01;
		if self.curRotationNum >= self.rotationNumber - 1 then
			-- 额外缓冲
			self.curNum = self.curNum ~= nil and self.curNum + 1 or 1;
			self.curSecNum = self.lastNum + self.residue * (self.curNum - 1);
		else
			-- y = a * x ^ 2
			self.curSecNum = self.accelateNum * Mathf.Pow(self.curRotationNum, 2);
		end
		Lua_CommonUtil.addTimer("LuckyTurntable_RewardRotation", self.curSecNum, self, self.updateRewardRotation);
	end
end

-- 结束抽奖旋转动画
function Lua_LuckyTurntableWindow:endRewardRotation()
	if self.startRewardRotation then
		self.startRewardRotation = false;
		Lua_CommonUtil.removeTimer(self, self.updateRewardRotation);
	end
end

-- 发光外圈
function Lua_LuckyTurntableWindow:startLighting()
	if self.startLight ~= true then
		self.startLight = true;
		self.lightCount = 7;
		self:updateLight();
		Lua_CommonUtil.addTimer("LuckyTurntable_lighting", 0.01, self, self.updateLight);
	end
end

-- 闪烁控制
function Lua_LuckyTurntableWindow:updateLight()
	self.lightCount = self.lightCount - 1;
	self.showItemArr[self.rotationCount]:setEnable(self.lightCount % 2 ~= 0);

	if self.lightCount == 1 then
		self:endLighting();
		self:showRewardsInfo(); -- 展示奖励
	end
end

-- 结束闪烁
function Lua_LuckyTurntableWindow:endLighting()
	if self.startLight then
		self.startLight = false;
		Lua_CommonUtil.removeTimer(self, self.updateLight);
	end
end

-- 当VIP等级改变时，更新普通轮盘十连抽消耗的道具、及数量
function Lua_LuckyTurntableWindow:updateNormalTurntableTenCost(ordinaryTurnTableManyCost)
	if self.curType == Lua_LuckyTurntableData.ordinaryTurnTable then
		self.tenCoinId = ordinaryTurnTableManyCost.id; -- 十抽消耗道具id
		self.tenCostNum = ordinaryTurnTableManyCost.costNum;-- 十次抽奖消耗的道具数量
		self:openManyBtn();
	end
end

-- 奖励道具显示窗口关闭后，更新道具信息（置灰）心愿值
function Lua_LuckyTurntableWindow:resetRewardStage()
	self.mask:setEnable(false);
	local turnTableInfo = DataCenter.luckyTurntableData.turnTableInfo[self.curType];
	if turnTableInfo == nil then
		return;
	end

	self:updateWishValue();
	self:updateRewardInfo();
	self:updateRecordTxt(turnTableInfo.recordInfo[1]);
	if not DataCenter.luckyTurntableData.againReward then
		self:startIdleRotation();
	end
end

function Lua_LuckyTurntableWindow:onMaskClick(go)
	OperateAlert.showLangValue(200704);
end

function Lua_LuckyTurntableWindow:onIntroduceClick(go)
	Lua_WindowUtil.openWin("Lua_LuckyTurntableRuleWindow", Lua_WinParam.ACTION_OPEN, self.curType);
end

function Lua_LuckyTurntableWindow:onSelectWishRewardClick(go)
	Lua_WindowUtil.openWin("Lua_LuckyWishRewardWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_LuckyTurntableWindow:onSkipAniBoxClick(state)
	self.skipAniState = state;
	local isSkip = state and 1 or 0;
	Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sSkipRotateAnimation(self.curType, isSkip);
end

function Lua_LuckyTurntableWindow:onShowRecordInfoClick(go)
	Lua_WindowUtil.openWin("Lua_LuckyTurntableRecordWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_LuckyTurntableWindow:onOneBtnClick(go)
	if self.wishId == 0 then
		OperateAlert.showLangValue(200705);
		return;
	end

	if DataCenter.packData:getItemCountById(self.oneCoinId) >= self.oneCostNum then
		if self.curType == Lua_LuckyTurntableData.ordinaryTurnTable or 
		  (self.curType == Lua_LuckyTurntableData.seniorTurnTable and DataCenter.heroData:isBagEnough(1)) then
			self.mask:setEnable(true);
			self:endIdleRotation(); -- 停止待机旋转
			DataCenter.chatData:setBoardPlayState(2, false); -- 拦截广播
			Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sTurntableRewardInfo(1, self.curType);
		else
			self:closeShowRewardWindow();
			OperateAlert.showLangValue(200719);
		end
	else
		self:startIdleRotation(); -- 待机旋转
		self:closeShowRewardWindow();
		DataCenter.packUtil:openPathWindow(self.oneCoinId);
	end
end

-- 当消耗道具不足时，关闭Lua_LuckyShowRewardWindow;
function Lua_LuckyTurntableWindow:closeShowRewardWindow()
	if Lua_WindowUtil.isWindowShowing("Lua_LuckyShowRewardWindow") then
		-- 奖励显示界面上是否再次抽奖的开关
		DataCenter.luckyTurntableData.againReward = false;
		Lua_WindowUtil.openWin("Lua_LuckyShowRewardWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_LuckyTurntableWindow:onFreeSpClick(go)
	local refreshState = DataCenter.luckyTurntableData.turnTableInfo[self.curType].refreshState;
	local itemInfo = DataCenter.luckyTurntableUtil:getTurntableConstConfig("normal_pay_refresh_consume", 4);
	if refreshState == 1 or DataCenter.moneyData:isMoneyEnough(itemInfo[1][1], itemInfo[1][2], true, true) then
		Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sRefreshLuckyTurntableInfo();
	end
end

function Lua_LuckyTurntableWindow:onManayBtnClick(go)
	-- 多抽按钮是否解锁
	if not self.isOpenManyBtn then
		OperateAlert.show(LanUtil.formateStr(200706, self.vipLvLimit));
		return;
	end
	-- 心愿英雄是否为空
	if self.wishId == 0 then
		OperateAlert.showLangValue(200705);
		return;
	end
	
	if DataCenter.packData:getItemCountById(self.tenCoinId) >= self.tenCostNum then
		if self.curType == Lua_LuckyTurntableData.ordinaryTurnTable or 
		  (self.curType == Lua_LuckyTurntableData.seniorTurnTable and DataCenter.heroData:isBagEnough(1)) then
			self.mask:setEnable(true);
			self:endIdleRotation(); -- 停止待机旋转
			DataCenter.chatData:setBoardPlayState(2, false); -- 拦截广播
			Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sTurntableRewardInfo(2, self.curType);
		else
			self:closeShowRewardWindow();
			OperateAlert.showLangValue(200719);
		end
	else
		self:startIdleRotation(); -- 待机旋转
		self:closeShowRewardWindow();
		DataCenter.packUtil:openPathWindow(self.tenCoinId);
	end
end

function Lua_LuckyTurntableWindow:dispose()
	if self.wishIcon ~= nil then
		self.wishIcon:dispose();
		self.wishIcon = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:dispose();
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	self:endFreeTimer(); -- 移除免费文本倒计时计时器
	self:endIdleRotation(); -- 移除待机旋转动画计时器
	self:endRewardRotation(); -- 移除旋转动画计时器
	self:endLighting(); -- 移除闪烁计时器
	Lua_CommonUtil.removeTimer(self, self.onRotatingSp);
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_TurntableItem = class("Lua_TurntableItem", Lua_DisplayObject);
function Lua_TurntableItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TurntableItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardIcon = Lua_ItemIcon.new(self.content);
	self.rewardIcon:setCanClick(true);
end

function Lua_TurntableItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.reward_item[1], data.reward_item[2]);
	local isGray = data.times ~= nil and data.times <= 0;
	self.rewardIcon:setData(tvo);
	self.rewardIcon:setGray(isGray);
	-- 预留后期特效
	-- self.rewardIcon:showEffect(isGray == false and self.data.is_effect == 1);

	local rewardIconTxt = self.rewardIcon._txt_right_down == nil and "txt_right_top" or "txt_right_down";
	self.rewardIcon[rewardIconTxt].fontSize = 26;
	self.rewardIcon[rewardIconTxt].pivot = Lua_WindowUtil.getPivot(5);
	self.rewardIcon[rewardIconTxt].alignmentValue = 4;
	self.rewardIcon[rewardIconTxt]:setLocation(89, -35);

	local spName = "ui_xyzp_widget_005"; -- ui_xyzp_toggle_002_f
	self:setIconBg(spName);
end

function Lua_TurntableItem:setIconBg(spriteName)
	self.rewardIcon.iconBg:setAltas("turntable_atlas", spriteName);
	self.rewardIcon.iconBg:resetSize();
	self.rewardIcon.iconBg:setScale(0.9, 0.9, 0.9);
end

function Lua_TurntableItem:dispose()
	if self.rewardIcon ~= nil then
		self.rewardIcon:dispose()
		self.rewardIcon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end