-- 幸运转盘-心愿奖励
Lua_LuckyWishRewardWindow = class("Lua_LuckyWishRewardWindow", Lua_Window);
function Lua_LuckyWishRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LuckyWishRewardWindow";
	self.skinName = "LuckyWishRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
end

function Lua_LuckyWishRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnClose:setLocation(300, 333);

	self.wishRewardList = Lua_DragList.new(self.content, 575, 252, Lua_AxisDefine.Vertical);
	self.wishRewardList:setListCell(Lua_wishRewardItem, 115, 112, 5);
	self.wishRewardList:setLocation(0, 157, 0);
	self.wishRewardList:setCellSpacing(0, 15);
	
	local curSelectType = DataCenter.luckyTurntableData.curSelectType;
	-- 高级轮盘
	if curSelectType == Lua_LuckyTurntableData.seniorTurnTable then
		self.winBg:setLocation(0, 58.5, 0);
		self.winBg:SetDimensions(700, 680);
		self.sureBtn:setLocation(150, -210);
		self.cancelBtn:setLocation(-150, -210);

		self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
	    self.campSiftPanel:setLocation(-32, -21, 0);
	    self.campSiftPanel:setSiftItem(73,"595959",28);
	    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
	    self.campSiftPanel:setCallBack(self, self.onCampSelected);
	    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
		
		self.winBg:SetDimensions(702, 529);
		self.winBg:setLocation(0, 113);
		self.sureBtn:setLocation(164, -88);
		self.cancelBtn:setLocation(-169, -88);
		self.selectHeroCampSp:setEnable(true);
	else -- 初级轮盘
		self.winBg:SetDimensions(702, 462);
		self.winBg:setLocation(0, 146);
		self.sureBtn:setLocation(164, -19);
		self.cancelBtn:setLocation(-169, -19);
		self.selectHeroCampSp:setEnable(false);
		self:onCampSelected(Lua_HeroUtil.All_TYPE)
	end

	self.sureBtn:addClickFuntion(self, self.onSureClick);
	self.cancelBtn:addClickFuntion(self, self.hide);
	self:addLuaEvent("UPDATE_SELECT_HERO", self, self.selectWishRewardByCampType);
end

function Lua_LuckyWishRewardWindow:onCampSelected(curCampType)
	if self.curCampType == curCampType then
		return;
	end
	self.curCampType = curCampType;

	self:selectWishRewardByCampType();
end

function Lua_LuckyWishRewardWindow:selectWishRewardByCampType(isMove)
	local curSelectType = DataCenter.luckyTurntableData.curSelectType;
	local wishRewardInfoArr = DataCenter.luckyTurntableUtil:getWishRewardInfoByType(curSelectType);
	if curSelectType == Lua_LuckyTurntableData.seniorTurnTable and self.curCampType ~= Lua_HeroUtil.All_TYPE then
		local heroVo;
		local showInfoArr = Array();
		for i = 1, wishRewardInfoArr:getSize() do
			heroVo = Lua_HeroVo.createToolVo(wishRewardInfoArr[i].reward_item[1], wishRewardInfoArr[i].reward_item[2]);
			if heroVo.campType == self.curCampType then
				showInfoArr:add(wishRewardInfoArr[i]);
			end
		end
		wishRewardInfoArr = showInfoArr;
	end
	self.wishRewardList:setArrayData(wishRewardInfoArr);

	if isMove == false then return; end
	self.wishRewardList:moveToIndex(1, true);
	local selectWishReward = DataCenter.luckyTurntableData.selectWishReward[curSelectType];
	for i = 1, wishRewardInfoArr:getSize() do
		if wishRewardInfoArr[i] == selectWishReward then
			self.wishRewardList:moveToIndex(i, true);
			break;
		end
	end
end

function Lua_LuckyWishRewardWindow:onSureClick(go)
	local curSelectType = DataCenter.luckyTurntableData.curSelectType;
	local wishId = DataCenter.luckyTurntableData.turnTableInfo[curSelectType].wishId;
	local selectWishReward = DataCenter.luckyTurntableData.selectWishReward[curSelectType];
	if wishId == 0 and selectWishReward == nil then
		OperateAlert.showLangValue(200705);
	else
		Lua_ProxyManager.getProxy("Lua_LuckyTurntableProxy"):sTurntableWishRewardInfo(curSelectType, selectWishReward.id);
		self:hide();
	end
end

function Lua_LuckyWishRewardWindow:dispose()
	if self.wishRewardList ~= nil then
		self.wishRewardList:dispose();
		self.wishRewardList = nil;
	end

	local curSelectType = DataCenter.luckyTurntableData.curSelectType;
	local wishId = DataCenter.luckyTurntableData.turnTableInfo[curSelectType].wishId;
	if wishId == 0 then
		DataCenter.luckyTurntableData.selectWishReward[curSelectType] = nil;
	else
		DataCenter.luckyTurntableData.selectWishReward[curSelectType] = DataCenter.luckyTurntableUtil:getWishRewardByWishId(wishId);
	end
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end
	self:superCall("dispose");
end






--------------------------------------------------





Lua_wishRewardItem = class("Lua_wishRewardItem", Lua_ListCell);
function Lua_wishRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_wishRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.wishRewardIcon = Lua_ItemIcon.new(self.content);
	self.wishRewardIcon:setScale(0.9, 0.9, 0.9);
end

function Lua_wishRewardItem:setData(data)
	if data == nil then
		return;
	end
	self.data = data;

	local curSelectType = DataCenter.luckyTurntableData.curSelectType;
	local selectId = DataCenter.luckyTurntableData.selectWishReward[curSelectType];
	local vo = Lua_ToolVo.createToolVo(data.reward_item[1], data.reward_item[2]);
	self.campType = vo.campType;
	self.wishRewardIcon:setData(vo);
	self.wishRewardIcon:setDrawMask(selectId == self.data);
end

function Lua_wishRewardItem:onPressClick()
	local curSelectType = DataCenter.luckyTurntableData.curSelectType;
	DataCenter.luckyTurntableData.selectWishReward[curSelectType] = self.data;

	Lua_MsgUtil.callFunc("UPDATE_SELECT_HERO", false);
end

function Lua_wishRewardItem:dispose()
	if self.wishRewardIcon ~= nil then
		self.wishRewardIcon:dispose();
		self.wishRewardIcon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end